[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 1.4 Parameter Mode Options

The parameter mode options are listed below. Except as otherwise noted, any combination of parameter mode options may be selected together, and except as noted, the settings of these options can be varied without breaking the application.

`-q, --quiet`

  `avram` normally informs the user when writing an output file with a short message to standard output. This option suppresses such messages. This option is compatible with any application and any other parameter mode option except ‘`-a`’.

`-a, --ask-to-overwrite`

  Selecting this option will cause `avram` to ask permission interactively before overwriting an existing file, and to refrain from overwriting it without permission, in which case the contents that were to be written will be lost. This option overrides ‘`-q`’ and is compatible with any other parameter mode option or application.

`-.EXT`

  An option beginning with a dash followed by a period specifies a default extension for input file names. If `avram` doesn’t find a file named on the command line, and the filename doesn’t already contain a period, `avram` will try to find a file having a similar name but with the default extension appended. The default extension given by this option takes precedence over the hard coded default extensions of `.fun` and `.avm`. At most one default extension can be supplied. This option is compatible with any other parameter mode option and compatible with any application.

`-d, --default-to-stdin`

  If no filename parameter appears on the command line (other than the name of the virtual code file), this option directs `avram` to read the contents of standard input as if it were specified as a command line parameter. (Standard input can also be specified explicitly as a dash. See Command Line Syntax.) This option is compatible with any application and any other parameter mode option except ‘`-m`’.

`-m, --map-to-each-file`

  Normally `avram` loads the entire contents of all files named on the command line into memory so as to evaluate the virtual machine code application on all of them together. This option can be used to save memory in the case of applications that operate on multiple files independently. It causes `avram` to load only one file at a time and to perform the relevant evaluation and output before loading the next one. Application specific options and standard input (if specified) are read only once and reused. This option is incompatible with ‘`-d`’, and not necessarily compatible with all applications, although some may work both with and without it.

`-i, --interactive`

  This option is used in the case of applications that interact with other programs through shell commands. An application that is meant to be invoked in this way requires this option and will not work without it, nor will applications that are not of this type work with it. This option is implied by ‘`-t`’ and ‘`-s`’, and is compatible with any other parameter mode option.

`-s, --step`

  This option is used in the case of applications that interact with other programs through shell commands, similarly to ‘`-i`’, and can substitute for it (see above). The option has the additional effect of causing shell commands issued by `avram` on behalf of the application to be written with their results to standard output, and to cause `avram` to pause after displaying each shell command until a key is pressed. This capability may be useful for debugging or auditing purposes but does not otherwise alter the effects of the application. This option is compatible with any other parameter mode option.

`-t, --trace`

  This option is used in the case of applications that interact with other programs through shell commands, but only by way of the `interact` combinator, for which it provides developers a means of low level debugging, particularly deadlock detection. When this option is selected, a verbose trace of all characters exchanged between the functional transducer and the external application are written to standard output, along with some additional control flow diagnostics. This option is compatible with any other parameter mode option.

`-p, --parameterized`

  Normally `avram` tries to guess whether to operate in filter mode or parameter mode based on the options used and the parameters. If there are no parameters and no options, it will default to filter mode, and try to read standard input. However, if this option is selected, it will use parameter mode (and therefore not try to read standard input unless required).

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

This document was generated on November 8, 2012 using texi2html 1.82.